Index: drivers/scsi/nsp32.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/nsp32.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/nsp32.c	22 Jul 2004 19:50:05 -0000	1.1
+++ drivers/scsi/nsp32.c	4 Aug 2004 01:29:35 -0000	1.2
@@ -1621,1542 +1629,1452 @@
 }
 #undef SPRINTF
 
+
+
 /*
- * Note: n_io_port is defined as 0x7f because I/O register port is
- *	 assigned as:
- *	0x800-0x8ff: memory mapped I/O port
- *	0x900-0xbff: (map same 0x800-0x8ff I/O port image repeatedly)
- *	0xc00-0xfff: CardBus status registers
+ * Reset parameters and call scsi_done for data->cur_lunt.
+ * Be careful setting SCpnt->result = DID_* before calling this function.
  */
-static int nsp32_detect(Scsi_Host_Template *sht)
+static void nsp32_scsi_done(Scsi_Cmnd *SCpnt)
 {
-	struct Scsi_Host *host;	/* registered host structure */
-	int ret;
-	nsp32_hw_data *data;
-	int i, j;
-
-	nsp32_dbg(NSP32_DEBUG_REGISTER, "enter");
+	nsp32_hw_data *data = (nsp32_hw_data *)SCpnt->device->host->hostdata;
+	unsigned int   base = SCpnt->device->host->io_port;
 
 	/*
-	 * register this HBA as SCSI device
+	 * unmap pci
 	 */
-	host = scsi_register(sht, sizeof(nsp32_hw_data));
-	if (host == NULL) {
-		nsp32_msg (KERN_ERR, "failed to scsi register");
-		goto err;
+	if (SCpnt->request_bufflen == 0) {
+		goto skip;
 	}
 
-	/*
-	 * set nsp32_hw_data
-	 */
-	data = (nsp32_hw_data *)host->hostdata;
-	memset(data, 0, sizeof(nsp32_hw_data));
-
-	data->IrqNumber   = nsp32_data_base.IrqNumber;
-	data->BaseAddress = nsp32_data_base.BaseAddress;
-	data->NumAddress  = nsp32_data_base.NumAddress; 
-	data->MmioAddress = nsp32_data_base.MmioAddress;
-	data->Pci         = nsp32_data_base.Pci;
-	data->pci_devid   = nsp32_data_base.pci_devid;
-
-	host->irq         = data->IrqNumber;
-	host->io_port	  = data->BaseAddress;
-	host->unique_id	  = data->BaseAddress;
-	host->n_io_port	  = data->NumAddress;
-	host->base        = data->MmioAddress;
-	scsi_set_pci_device(host, data->Pci);
-
-	data->Host        = host;
-	spin_lock_init(&(data->Lock));
-
-	data->curlunt     = NULL;
-	data->curtarget   = NULL;
+	if (SCpnt->use_sg) {
+		pci_unmap_sg(data->Pci,
+			     (struct scatterlist *)SCpnt->buffer,
+			     SCpnt->use_sg,
+			     scsi_to_pci_dma_dir(SCpnt->sc_data_direction));
+	} else {
+		pci_unmap_single(data->Pci,
+				 (u32)SCpnt->SCp.have_data_in,
+				 SCpnt->request_bufflen,
+				 scsi_to_pci_dma_dir(SCpnt->sc_data_direction));
+	}
 
+ skip:
 	/*
-	 * Bus master transfer mode is supported currently.
+	 * clear TRANSFERCONTROL_BM_START
 	 */
-	data->trans_method	= NSP32_TRANSFER_BUSMASTER;
+	nsp32_write2(base, TRANSFER_CONTROL, 0);
+	nsp32_write4(base, BM_CNT,           0);
 
 	/*
-	 * Set clock div, CLOCK_4 (HBA has external clock, and
-	 * dividing * 100ns/4).
-	 * Currently CLOCK_4 has only tested, not for CLOCK_2/PCICLK yet.
+	 * call scsi_done
 	 */
-	data->clock = CLOCK_4;
+	(*SCpnt->scsi_done)(SCpnt);
 
 	/*
-	 * Select appropriate nsp32_sync_table and set I_CLOCKDIV.
+	 * reset parameters
 	 */
-	switch (data->clock) {
-	case CLOCK_4:
-		/* If data->clock is CLOCK_4, then select 40M sync table. */
-		data->synct = nsp32_sync_table_40M;
-		data->syncnum = nsp32_table_40M_num;
-		break;
-	case CLOCK_2:
-		/* If data->clock is CLOCK_2, then select 20M sync table. */
-		data->synct = nsp32_sync_table_20M;
-		data->syncnum = nsp32_table_20M_num;
-		break;
-	case PCICLK:
-		/* If data->clock is PCICLK, then select pci sync table. */
-		data->synct = nsp32_sync_table_pci;
-		data->syncnum = nsp32_table_pci_num;
-		break;
-	default:
-		nsp32_msg(KERN_WARNING,
-			  "Invalid clock div is selected, set CLOCK_4.");
-		/* Use default value CLOCK_4 */
-		data->clock = CLOCK_4;
-		data->synct = nsp32_sync_table_40M;
-		data->syncnum = nsp32_table_40M_num;
-	}
+	data->cur_lunt->SCpnt = NULL;
+	data->cur_lunt        = NULL;
+	data->cur_target      = NULL;
+	data->CurrentSC       = NULL;
+}
 
-	/*
-	 * setup nsp32_lunt
-	 */
-	data->lunt_list = (struct nsp32_lunt *)
-		kmalloc(sizeof(struct nsp32_lunt) * MAX_TARGET * MAX_LUN,
-			GFP_KERNEL);
-	if (data->lunt_list == NULL) {
-		nsp32_msg(KERN_ERR, "cannot allocate LUN memory");
-		goto scsi_unregister;
-	}
-	nsp32_dbg(NSP32_DEBUG_REGISTER, "0x%x 0x%x",
-		  data->lunt_list, sizeof(struct nsp32_lunt)*MAX_TARGET*MAX_LUN);
 
-	/*
-	 * setup DMA 
-	 */
-	if (pci_set_dma_mask(data->Pci, 0xffffffffUL)) {
-		nsp32_msg (KERN_ERR, "failed to set PCI DMA mask");
-		goto kfree_lunt;
-	}
+/*
+ * Bus Free Occur
+ *
+ * Current Phase is BUSFREE. AutoSCSI is automatically execute BUSFREE phase
+ * with ACK reply when below condition is matched:
+ *	MsgIn 00: Command Complete.
+ *	MsgIn 02: Save Data Pointer.
+ *	MsgIn 04: Diconnect.
+ * In other case, unexpected BUSFREE is detected.
+ */
+static int nsp32_busfree_occur(Scsi_Cmnd *SCpnt, unsigned short execph)
+{
+	nsp32_hw_data *data = (nsp32_hw_data *)SCpnt->device->host->hostdata;
+	unsigned int base   = SCpnt->device->host->io_port;
 
-	/*
-	 * allocate autoparam DMA resource.
-	 */
-	data->autoparam = pci_alloc_consistent(data->Pci, AUTOPARAM_SIZE, &data->apaddr);
-	if (data->autoparam == NULL) {
-		nsp32_msg(KERN_ERR, "failed to allocate DMA memory");
-		goto kfree_lunt;
-	}
+	nsp32_dbg(NSP32_DEBUG_BUSFREE, "enter execph=0x%x", execph);
+	show_autophase(execph);
+
+	nsp32_write4(base, BM_CNT,           0);
+	nsp32_write2(base, TRANSFER_CONTROL, 0);
 
 	/*
-	 * allocate scatter-gather DMA resource.
+	 * MsgIn 02: Save Data Pointer
+	 *
+	 * VALID:
+	 *   Save Data Pointer is received. Adjust pointer.
+	 *   
+	 * NO-VALID:
+	 *   SCSI-3 says if Save Data Pointer is not received, then we restart
+	 *   processing and we can't adjust any SCSI data pointer in next data
+	 *   phase.
 	 */
-	data->sg_list = pci_alloc_consistent(data->Pci, 
-			(sizeof(struct nsp32_sgtable) * NSP_SG_SIZE * MAX_TARGET * MAX_LUN),
-			 &data->sgaddr);
-	if (data->sg_list == NULL) {
-		nsp32_msg(KERN_ERR, "failed to allocate DMA memory");
-		goto free_autoparam;
-	}
+	if (execph & MSGIN_02_VALID) {
+		nsp32_dbg(NSP32_DEBUG_BUSFREE, "MsgIn02_Valid");
 
-	for (i=0; i<MAX_TARGET; i++) {
-		for (j=0; j<MAX_LUN; j++) {
-			data->lunt[i][j] = data->lunt_list + (i * MAX_LUN + j);
-		}
-	}
+		/*
+		 * Check sack_cnt/saved_sack_cnt, then adjust sg table if
+		 * needed.
+		 */
+		if (!(execph & MSGIN_00_VALID) && 
+		    ((execph & DATA_IN_PHASE) || (execph & DATA_OUT_PHASE))) {
+			unsigned int sacklen, s_sacklen;
+
+			/*
+			 * Read SACK count and SAVEDSACK count, then compare.
+			 */
+			sacklen   = nsp32_read4(base, SACK_CNT      );
+			s_sacklen = nsp32_read4(base, SAVED_SACK_CNT);
+
+			/*
+			 * If SAVEDSACKCNT == 0, it means SavedDataPointer is
+			 * come after data transfering.
+			 */
+			if (s_sacklen > 0) {
+				/*
+				 * Comparing between sack and savedsack to
+				 * check the condition of AutoMsgIn03.
+				 *
+				 * If they are same, set msgin03 == TRUE,
+				 * COMMANDCONTROL_AUTO_MSGIN_03 is enabled at
+				 * reselection.  On the other hand, if they
+				 * aren't same, set msgin03 == FALSE, and
+				 * COMMANDCONTROL_AUTO_MSGIN_03 is disabled at
+				 * reselection.
+				 */
+				if (sacklen != s_sacklen) {
+					data->cur_lunt->msgin03 = FALSE;
+				} else {
+					data->cur_lunt->msgin03 = TRUE;
+				}
 
-	for (i=0; i<MAX_TARGET; i++) {
-		for (j=0; j<MAX_LUN; j++) {
-			struct nsp32_lunt *lp = data->lunt[i][j];
-			lp->sglun = (struct nsp32_sglun *)
-				(data->sg_list + (i * MAX_LUN + j));
-			lp->sglun_paddr = data->sgaddr +
-				(long)((i * MAX_LUN + j) 
-				       * sizeof(struct nsp32_sglun));
-			lp->SCpnt = NULL;
-			lp->save_datp = 0;
-			lp->msgin03 = FALSE;
-			lp->sg_num = 0;
-			lp->cur_entry = 0;
+				nsp32_adjust_busfree(SCpnt, s_sacklen);
+			}
 		}
+
+		/* This value has not substitude with valid value yet... */
+		//data->cur_lunt->save_datp = data->cur_datp;
+	} else {
+		/*
+		 * no processing.
+		 */
+	}
+	
+	if (execph & MSGIN_03_VALID) {
+		/* MsgIn03 was valid to be processed. No need processing. */
 	}
 
 	/*
-	 * setup target
+	 * target SDTR check
 	 */
-	for (i=0; i<MAX_TARGET; i++) {
-		struct nsp32_target *target = &data->target[i];
-
-		target->limit_entry  = 0;
-		target->sync_flag    = 0;
-		nsp32_set_async(data, target);
+	if (data->cur_target->sync_flag & SDTR_INITIATOR) {
+		/*
+		 * SDTR negotiation pulled by the initiator has not
+		 * finished yet. Fall back to ASYNC mode.
+		 */
+		nsp32_set_async(data, data->cur_target);
+		data->cur_target->sync_flag &= ~SDTR_INITIATOR;
+		data->cur_target->sync_flag |= SDTR_DONE;
+	} else if (data->cur_target->sync_flag & SDTR_TARGET) {
+		/*
+		 * SDTR negotiation pulled by the target has been
+		 * negotiating.
+		 */
+		if (execph & (MSGIN_00_VALID | MSGIN_04_VALID)) {
+			/* 
+			 * If valid message is received, then
+			 * negotiation is succeeded.
+			 */
+		} else {
+			/*
+			 * On the contrary, if unexpected bus free is
+			 * occurred, then negotiation is failed. Fall
+			 * back to ASYNC mode.
+			 */
+			nsp32_set_async(data, data->cur_target);
+		}
+		data->cur_target->sync_flag &= ~SDTR_TARGET;
+		data->cur_target->sync_flag |= SDTR_DONE;
 	}
 
 	/*
-	 * EEPROM check
+	 * It is always ensured by SCSI standard that initiator
+	 * switches into Bus Free Phase after
+	 * receiving message 00 (Command Complete), 04 (Disconnect).
+	 * It's the reason that processing here is valid.
 	 */
-	ret = nsp32_getprom_param(data);
-	if (ret == FALSE) {
-		data->resettime = 3;	/* default 3 */
+	if (execph & MSGIN_00_VALID) {
+		/* MsgIn 00: Command Complete */
+		nsp32_dbg(NSP32_DEBUG_BUSFREE, "command complete");
+
+		SCpnt->SCp.Status  = nsp32_read1(base, SCSI_CSB_IN);
+		SCpnt->SCp.Message = 0;
+		nsp32_dbg(NSP32_DEBUG_BUSFREE, 
+			  "normal end stat=0x%x resid=0x%x\n",
+			  SCpnt->SCp.Status, SCpnt->resid);
+		SCpnt->result = (DID_OK             << 16) |
+			        (SCpnt->SCp.Message <<  8) |
+			        (SCpnt->SCp.Status  <<  0);
+		nsp32_scsi_done(SCpnt);
+		/* All operation is done */
+		return TRUE;
+	} else if (execph & MSGIN_04_VALID) {
+		/* MsgIn 04: Disconnect */
+		SCpnt->SCp.Status  = nsp32_read1(base, SCSI_CSB_IN);
+		SCpnt->SCp.Message = 4;
+		
+		nsp32_dbg(NSP32_DEBUG_BUSFREE, "disconnect");
+		return TRUE;
+	} else {
+		/* Unexpected bus free */
+		nsp32_msg(KERN_WARNING, "unexpected bus free occurred");
+
+		/* DID_ERROR? */
+		//SCpnt->result   = (DID_OK << 16) | (SCpnt->SCp.Message << 8) | (SCpnt->SCp.Status << 0);
+		SCpnt->result = DID_ERROR << 16;
+		nsp32_scsi_done(SCpnt);
+		return TRUE;
 	}
+	return FALSE;
+}
 
-	/*
-	 * setup HBA
-	 */
-	nsp32hw_init(host);
 
-	snprintf(data->info_str, sizeof(data->info_str),
-		 "NinjaSCSI-32Bi/UDE: irq %d, io 0x%lx+0x%x",
-		 host->irq, host->io_port, host->n_io_port);
+/*
+ * nsp32_adjust_busfree - adjusting SG table
+ *
+ * Note: This driver adjust the SG table using SCSI ACK
+ *       counter instead of BMCNT counter!
+ */
+static void nsp32_adjust_busfree(Scsi_Cmnd *SCpnt, unsigned int s_sacklen)
+{
+	nsp32_hw_data *data = (nsp32_hw_data *)SCpnt->device->host->hostdata;
+	int                   old_entry = data->cur_entry;
+	int                   new_entry;
+	int                   sg_num = data->cur_lunt->sg_num;
+	nsp32_sgtable *sgt    = data->cur_lunt->sglun->sgt;
+	unsigned int          restlen, sentlen;
+	u32                   len, addr;
 
-	sht->name = data->info_str;
+	nsp32_dbg(NSP32_DEBUG_SGLIST, "old resid=0x%x", SCpnt->resid);
+
+	/* adjust saved SACK count with 4 byte start address boundary */
+	s_sacklen -= le32_to_cpu(sgt[old_entry].addr) & 3;
 
 	/*
-	 * SCSI bus reset
-	 *
-	 * Note: It's important to reset SCSI bus in initialization phase.
-	 *     NinjaSCSI-32Bi/UDE HBA EEPROM seems to exchange SDTR when system is
-	 *     coming up, so SCSI devices connected to HBA is set as
-	 *     un-asynchronous mode.  It brings the merit that this HBA is
-	 *     ready to start synchronous transfer without any preparation,
-	 *     but we are difficult to control transfer speed.  In addition,
-	 *     it prevents device transfer speed from effecting EEPROM start-up
-	 *     SDTR.  NinjaSCSI-32Bi/UDE has the feature if EEPROM is set as Auto
-	 *     Mode, then FAST-10M is selected when SCSI devices are connected
-	 *     same or more than 4 devices.  It should be avoided depending on
-	 *     this specification Thus, resetting the SCSI bus restores all
-	 *     connected SCSI devices to asynchronous mode, then this driver
-	 *     put SDTR safely later, and we can control all SCSI device
-	 *     transfer mode.
+	 * calculate new_entry from sack count and each sgt[].len 
+	 * calculate the byte which is intent to send
 	 */
-	nsp32_do_bus_reset(data);
+	sentlen = 0;
+	for (new_entry = old_entry; new_entry < sg_num; new_entry++) {
+		sentlen += (le32_to_cpu(sgt[new_entry].len) & ~SGTEND);
+		if (sentlen > s_sacklen) {
+			break;
+		}
+	}
 
-	ret = request_irq(host->irq, do_nsp32_isr, SA_SHIRQ, "nsp32", data);
-	if (ret < 0) {
-		nsp32_msg(KERN_ERR, "Unable to allocate IRQ for NSP32 "
-			  "SCSI PCI controller. Interrupt: %d\n", host->irq);
-		goto free_sg_list;
+	/* all sgt is processed */
+	if (new_entry == sg_num) {
+		goto last;
 	}
 
-        /*
-         * PCI IO register
-         */
-	if(!request_region(host->io_port, host->n_io_port, "nsp32")) {
-		nsp32_msg(KERN_ERR, 
-			  "I/O region 0x%lx+0x%lx is already used",
-			  data->BaseAddress, data->length);
-		goto free_irq;
-        }
+	if (sentlen == s_sacklen) {
+		/* XXX: confirm it's ok or not */
+		/* In this case, it's ok because we are at 
+		   the head element of the sg. restlen is correctly calculated. */
+	}
 
-	return 1;
+	/* calculate the rest length for transfering */
+	restlen = sentlen - s_sacklen;
 
- free_irq:
-	free_irq(host->irq, data);
-
- free_autoparam:
-	pci_free_consistent(data->Pci, AUTOPARAM_SIZE, data->autoparam, data->apaddr);
-	
- free_sg_list:
-	pci_free_consistent(data->Pci,
-		(sizeof(struct nsp32_sgtable) * NSP_SG_SIZE * MAX_TARGET * MAX_LUN),
-		data->sg_list, data->sgaddr);
-	
- kfree_lunt:
-	kfree(data->lunt_list);
-
- scsi_unregister:
-	scsi_unregister(host);
-
- err:
-	return 0;
-}
-
-static int nsp32_release(struct Scsi_Host *shpnt)
-{
-	nsp32_hw_data *data = (nsp32_hw_data *)shpnt->hostdata;
-
-	if (data->lunt_list) {
-		kfree(data->lunt_list);
-	}
-
-	if (data->autoparam) {
-		pci_free_consistent(data->Pci, AUTOPARAM_SIZE,
-					data->autoparam, data->apaddr);
-	}
-
-	if (data->sg_list) {
-		pci_free_consistent(data->Pci, 
-			(sizeof(struct nsp32_sgtable) * NSP_SG_SIZE * MAX_TARGET * MAX_LUN),
-			data->sg_list, data->sgaddr);
-	}
-
-	DEBUG(0, "free irq\n");
-	if (shpnt->irq) {
-		free_irq(shpnt->irq, data);
-	}
+	/* update adjusting current SG table entry */
+	len  = le32_to_cpu(sgt[new_entry].len);
+	addr = le32_to_cpu(sgt[new_entry].addr);
+	addr += (len - restlen);
+	sgt[new_entry].addr = cpu_to_le32(addr);
+	sgt[new_entry].len  = cpu_to_le32(restlen);
 
-	DEBUG(0, "free io\n");
-	if (shpnt->io_port && shpnt->n_io_port) {
-		release_region(shpnt->io_port, shpnt->n_io_port);
-	}
+	/* set cur_entry with new_entry */
+	data->cur_entry = new_entry;
+ 
+	return;
 
-	if (data->MmioAddress != 0) {
-		iounmap((void *)(data->MmioAddress));
+ last:
+	if (SCpnt->resid < sentlen) {
+		nsp32_msg(KERN_ERR, "resid underflow");
 	}
 
-	return 0;
-}
+	SCpnt->resid -= sentlen;
+	nsp32_dbg(NSP32_DEBUG_SGLIST, "new resid=0x%x", SCpnt->resid);
 
-static const char *nsp32_info(struct Scsi_Host *shpnt)
-{
-	nsp32_hw_data *data = (nsp32_hw_data *)shpnt->hostdata;
+	/* update hostdata and lun */
 
-	return data->info_str;
+	return;
 }
 
 
 /*
- * error handler
+ * It's called MsgOut phase occur.
+ * NinjaSCSI-32Bi/UDE automatically processes up to 3 messages in
+ * message out phase. It, however, has more than 3 messages,
+ * HBA creates the interrupt and we have to process by hand.
  */
-static int nsp32_reset(Scsi_Cmnd *SCpnt, unsigned int reset_flags)
+static void nsp32_msgout_occur(Scsi_Cmnd *SCpnt)
 {
-	nsp32_dbg(NSP32_DEBUG_BUSRESET, "SCpnt=0x%p why=%d\n", SCpnt, reset_flags);
+	nsp32_hw_data *data = (nsp32_hw_data *)SCpnt->device->host->hostdata;
+	unsigned int base   = SCpnt->device->host->io_port;
+	//unsigned short command;
+	long new_sgtp;
+	int i;
+	
+	nsp32_dbg(NSP32_DEBUG_MSGOUTOCCUR,
+		  "enter: msgout_len: 0x%x", data->msgout_len);
 
-	nsp32_eh_bus_reset(SCpnt);
+	/*
+	 * If MsgOut phase is occurred without having any
+	 * message, then No_Operation is sent (SCSI-2).
+	 */
+	if (data->msgout_len == 0) {
+		nsp32_build_nop(SCpnt);
+	}
 
-	return SCSI_RESET_SUCCESS | SCSI_RESET_BUS_RESET;
-}
+	/*
+	 * Set SGTP ADDR current entry for restarting AUTOSCSI, 
+	 * because SGTP is incremented next point.
+	 * There is few statement in the specification...
+	 */
+ 	new_sgtp = data->cur_lunt->sglun_paddr + 
+		   (data->cur_lunt->cur_entry * sizeof(nsp32_sgtable));
 
-static int nsp32_eh_abort(Scsi_Cmnd *SCpnt)
-{
-	nsp32_hw_data *data = (nsp32_hw_data *)SCpnt->host->hostdata;
-	unsigned int base = data->BaseAddress;
+	/*
+	 * send messages
+	 */
+	for (i = 0; i < data->msgout_len; i++) {
+		nsp32_dbg(NSP32_DEBUG_MSGOUTOCCUR,
+			  "%d : 0x%x", i, data->msgoutbuf[i]);
 
-	nsp32_msg(KERN_WARNING, "abort");
+		/*
+		 * Check REQ is asserted.
+		 */
+		nsp32_wait_req(data, ASSERT);
 
-	if (data->curlunt->SCpnt == NULL) {
-		return (FAILED);
-	}
+		if (i == (data->msgout_len - 1)) {
+			/*
+			 * If the last message, set the AutoSCSI restart
+			 * before send back the ack message. AutoSCSI
+			 * restart automatically negate ATN signal.
+			 */
+			//command = (AUTO_MSGIN_00_OR_04 | AUTO_MSGIN_02);
+			//nsp32_restart_autoscsi(SCpnt, command);
+			nsp32_write2(base, COMMAND_CONTROL,
+					 (CLEAR_CDB_FIFO_POINTER |
+					  AUTO_COMMAND_PHASE     |
+					  AUTOSCSI_RESTART       |
+					  AUTO_MSGIN_00_OR_04    |
+					  AUTO_MSGIN_02          ));
+		}
+		/*
+		 * Write data with SACK, then wait sack is
+		 * automatically negated.
+		 */
+		nsp32_write1(base, SCSI_DATA_WITH_ACK, data->msgoutbuf[i]);
+		nsp32_wait_sack(data, NEGATE);
 
-	if (data->curtarget->sync_flag & (SDTR_INITIATOR | SDTR_TARGET)) {
-		/* reset SDTR negotiation */
-		data->curtarget->sync_flag = 0;
-	}
+		nsp32_dbg(NSP32_DEBUG_MSGOUTOCCUR, "bus: 0x%x\n",
+			  nsp32_read1(base, SCSI_BUS_MONITOR));
+	};
 
-	nsp32_write2(base, TRANSFER_CONTROL, 0);
-	nsp32_write2(base, BM_CNT, 0);
+	data->msgout_len = 0;
 
-	return (FAILED);
+	nsp32_dbg(NSP32_DEBUG_MSGOUTOCCUR, "exit");
 }
 
-static int nsp32_eh_bus_reset(Scsi_Cmnd *SCpnt)
+/*
+ * Restart AutoSCSI
+ *
+ * Note: Restarting AutoSCSI needs set:
+ *		SYNC_REG, ACK_WIDTH, SGT_ADR, TRANSFER_CONTROL
+ */
+static void nsp32_restart_autoscsi(Scsi_Cmnd *SCpnt, unsigned short command)
 {
-	nsp32_hw_data *data = (nsp32_hw_data *)SCpnt->host->hostdata;
-	unsigned int base = data->BaseAddress;
+	nsp32_hw_data *data = (nsp32_hw_data *)SCpnt->device->host->hostdata;
+	unsigned int   base = data->BaseAddress;
+	unsigned short transfer = 0;
 
-	nsp32_msg(KERN_INFO, "Bus Reset");	
-	nsp32_dbg(NSP32_DEBUG_BUSRESET, "SCpnt=0x%x", SCpnt);
+	nsp32_dbg(NSP32_DEBUG_RESTART, "enter");
 
-	nsp32_write2(base, IRQ_CONTROL, IRQ_CONTROL_ALL_IRQ_MASK);
-	nsp32_do_bus_reset(data);
-	nsp32_write2(base, IRQ_CONTROL, 0);
+	if (data->cur_target == NULL || data->cur_lunt == NULL) {
+		nsp32_msg(KERN_ERR, "Target or Lun is invalid");
+	}
 
-	return SUCCESS;	/* SCSI bus reset is succeeded at any time. */
-}
+	/*
+	 * set SYNC_REG
+	 * Don't set BM_START_ADR before setting this register.
+	 */
+	nsp32_write1(base, SYNC_REG, data->cur_target->syncreg);
 
-static void nsp32_do_bus_reset(nsp32_hw_data *data)
-{
-	unsigned int base = data->BaseAddress;
-	unsigned short intrdat;
-	int i;
+	/*
+	 * set ACKWIDTH
+	 */
+	nsp32_write1(base, ACK_WIDTH, data->cur_target->ackwidth);
 
 	/*
-	 * stop all transfer
-	 * clear TRANSFERCONTROL_BM_START
-	 * clear counter
+	 * set SREQ hazard killer sampling rate
 	 */
-	nsp32_write2(base, TRANSFER_CONTROL, 0);
-	nsp32_write4(base, BM_CNT,           0);
-	nsp32_write4(base, CLR_COUNTER, CLRCOUNTER_ALLMASK);
+	nsp32_write1(base, SREQ_SMPL_RATE, data->cur_target->sample_reg);
 
 	/*
-	 * fall back to asynchronous transfer mode
-	 * initialize SDTR negotiation flag
+	 * set SGT ADDR (physical address)
 	 */
-	for (i=0; i<MAX_TARGET; i++) {
-		struct nsp32_target *target = &data->target[i];
+	nsp32_write4(base, SGT_ADR, data->cur_lunt->sglun_paddr);
 
-		target->sync_flag = 0;
-		nsp32_set_async(data, target);
+	/*
+	 * set TRANSFER CONTROL REG
+	 */
+	transfer = 0;
+	transfer |= (TRANSFER_GO | ALL_COUNTER_CLR);
+	if (data->trans_method & NSP32_TRANSFER_BUSMASTER) {
+		if (SCpnt->request_bufflen > 0) {
+			transfer |= BM_START;
+		}
+	} else if (data->trans_method & NSP32_TRANSFER_MMIO) {
+		transfer |= CB_MMIO_MODE;
+	} else if (data->trans_method & NSP32_TRANSFER_PIO) {
+		transfer |= CB_IO_MODE;
 	}
+	nsp32_write2(base, TRANSFER_CONTROL, transfer);
 
 	/*
-	 * reset SCSI bus
+	 * restart AutoSCSI
+	 *
+	 * TODO: COMMANDCONTROL_AUTO_COMMAND_PHASE is needed ?
 	 */
-	nsp32_write1(base, SCSI_BUS_CONTROL, BUSCTL_RST);
-	udelay(RESET_HOLD_TIME);
-	nsp32_write1(base, SCSI_BUS_CONTROL, 0);
-	for(i = 0; i < 5; i++) {
-		intrdat = nsp32_read2(base, IRQ_STATUS); /* dummy read */
-		nsp32_dbg(NSP32_DEBUG_BUSRESET, "irq:1: 0x%x", intrdat);
-        }
+	command |= (CLEAR_CDB_FIFO_POINTER |
+		    AUTO_COMMAND_PHASE     |
+		    AUTOSCSI_RESTART       );
+	nsp32_write2(base, COMMAND_CONTROL, command);
 
-	data->CurrentSC = NULL;
+	nsp32_dbg(NSP32_DEBUG_RESTART, "exit");
 }
 
-static int nsp32_eh_host_reset(Scsi_Cmnd *SCpnt)
-{
-	struct Scsi_Host *host = SCpnt->host;
-	nsp32_hw_data *data = (nsp32_hw_data *)host->hostdata;
-	unsigned int base = data->BaseAddress;
-
-	nsp32_msg(KERN_INFO, "Host Reset");	
-	nsp32_dbg(NSP32_DEBUG_BUSRESET, "SCpnt=0x%x", SCpnt);
-
-	nsp32hw_init(host);
-	nsp32_write2(base, IRQ_CONTROL, IRQ_CONTROL_ALL_IRQ_MASK);
-	nsp32_do_bus_reset(data);
-	nsp32_write2(base, IRQ_CONTROL, 0);
-
-	return SUCCESS;	/* Host reset is succeeded at any time. */
-}
 
 /*
- * PCI/Cardbus probe/remove routine
+ * cannot run automatically message in occur
  */
-static int __devinit nsp32_probe(struct pci_dev *pdev, const struct pci_device_id *id)
-{
-	int ret;
-	nsp32_hw_data *data = &nsp32_data_base;
-
-	nsp32_dbg(NSP32_DEBUG_REGISTER, "enter");
+static void nsp32_msgin_occur(Scsi_Cmnd     *SCpnt,
+			      unsigned long  irq_status,
+			      unsigned short execph)
+{
+	nsp32_hw_data *data = (nsp32_hw_data *)SCpnt->device->host->hostdata;
+	unsigned int   base = SCpnt->device->host->io_port;
+	unsigned char  msg;
+	unsigned char  msgtype;
+	unsigned char  newlun;
+	unsigned short command  = 0;
+	int            msgclear = TRUE;
+	long           new_sgtp;
+	int            ret;
 
-        ret = pci_enable_device(pdev);
-	if (ret) {
-		nsp32_msg(KERN_ERR, "failed to enable pci device");
-		return ret;
-	}
+	/*
+	 * read first message
+	 *    Use SCSIDATA_W_ACK instead of SCSIDATAIN, because the procedure
+	 *    of Message-In have to be processed before sending back SCSI ACK.
+	 */
+	msg = nsp32_read1(base, SCSI_DATA_IN);
+	data->msginbuf[(unsigned char)data->msgin_len] = msg;
+	msgtype = data->msginbuf[0];
+	nsp32_dbg(NSP32_DEBUG_MSGINOCCUR,
+		  "enter: msglen: 0x%x msgin: 0x%x msgtype: 0x%x",
+		  data->msgin_len, msg, msgtype);
 
-	data->Pci = pdev;
-	data->pci_devid = id;
-	data->IrqNumber = pdev->irq;
-	data->BaseAddress = pci_resource_start(pdev, 0);
-	data->NumAddress = pci_resource_len(pdev, 0);
-	data->MmioAddress = (unsigned long)ioremap_nocache(
-		pci_resource_start(pdev, 1), pci_resource_len(pdev, 1));
+	/*
+	 * TODO: We need checking whether bus phase is message in?
+	 */
 
-	pci_set_master(pdev);
+	/*
+	 * assert SCSI ACK
+	 */
+	nsp32_sack_assert(data);
 
-#if (LINUX_VERSION_CODE > KERNEL_VERSION(2,5,2))
-	scsi_register_host(&driver_template);
-#else
-	scsi_register_module(MODULE_SCSI_HA, &driver_template);
-#endif
+	/*
+	 * processing IDENTIFY
+	 */
+	if (msgtype & 0x80) {
+		if (!(irq_status & IRQSTATUS_RESELECT_OCCUER)) {
+			/* Invalid (non reselect) phase */
+			goto reject;
+		}
 
-	nsp32_msg(KERN_INFO, "nsp32 irq: %i mmio: 0x%lx slot: %s model: %s",
-		  pdev->irq, data->MmioAddress, pdev->slot_name,
-		  nsp32_model[id->driver_data]);
+		newlun = msgtype & 0x1f; /* TODO: SPI-3 compliant? */
+		ret = nsp32_reselection(SCpnt, newlun);
+		if (ret == TRUE) {
+			goto restart;
+		} else {
+			goto reject;
+		}
+	}
+	
+	/*
+	 * processing messages except for IDENTIFY
+	 *
+	 * TODO: Messages are all SCSI-2 terminology. SCSI-3 compliance is TODO.
+	 */
+	switch (msgtype) {
+	/*
+	 * 1-byte message
+	 */
+	case COMMAND_COMPLETE:
+	case DISCONNECT:
+		/*
+		 * These messages should not be occurred.
+		 * They should be processed on AutoSCSI sequencer.
+		 */
+		nsp32_msg(KERN_WARNING, 
+			   "unexpected message of AutoSCSI MsgIn: 0x%x", msg);
+		break;
+		
+	case RESTORE_POINTERS:
+		/*
+		 * AutoMsgIn03 is disabled, and HBA gets this message.
+		 */
 
-	nsp32_dbg(NSP32_DEBUG_REGISTER, "exit");
+		if ((execph & DATA_IN_PHASE) || (execph & DATA_OUT_PHASE)) {
+			unsigned int s_sacklen;
 
-	return 0;
-}
+			s_sacklen = nsp32_read4(base, SAVED_SACK_CNT);
+			if ((execph & MSGIN_02_VALID) && (s_sacklen > 0)) {
+				nsp32_adjust_busfree(SCpnt, s_sacklen);
+			} else {
+				/* No need to rewrite SGT */
+			}
+		}
+		data->cur_lunt->msgin03 = FALSE;
 
-static void __devexit nsp32_remove(struct pci_dev *pdev)
-{
-	nsp32_dbg(NSP32_DEBUG_REGISTER, "enter");
-	
-#if (LINUX_VERSION_CODE > KERNEL_VERSION(2,5,2))
-	scsi_unregister_host(&driver_template);
-#else
-	scsi_unregister_module(MODULE_SCSI_HA, &driver_template);
-#endif
-}
+		/* Update with the new value */
 
-static struct pci_device_id nsp32_pci_table[] __devinitdata = {
-	{
-		vendor:      PCI_VENDOR_ID_IODATA,
-		device:      PCI_DEVICE_ID_NINJASCSI_32BI_CBSC_II,
-		subvendor:   PCI_ANY_ID,
-		subdevice:   PCI_ANY_ID,
-		driver_data: MODEL_IODATA,
-	},
-	{
-		vendor:      PCI_VENDOR_ID_WORKBIT,
-		device:      PCI_DEVICE_ID_NINJASCSI_32BI_KME,
-		subvendor:   PCI_ANY_ID,
-		subdevice:   PCI_ANY_ID,
-		driver_data: MODEL_KME,
-	},
-	{
-		vendor:      PCI_VENDOR_ID_WORKBIT,
-		device:      PCI_DEVICE_ID_NINJASCSI_32BI_WBT,
-		subvendor:   PCI_ANY_ID,
-		subdevice:   PCI_ANY_ID,
-		driver_data: MODEL_WORKBIT,
-	},
-	{
-		vendor:      PCI_VENDOR_ID_WORKBIT,
-		device:      PCI_DEVICE_ID_WORKBIT_STANDARD,
-		subvendor:   PCI_ANY_ID,
-		subdevice:   PCI_ANY_ID,
-		driver_data: MODEL_PCI_WORKBIT,
-	},
-	{
-		vendor:      PCI_VENDOR_ID_WORKBIT,
-		device:      PCI_DEVICE_ID_NINJASCSI_32BI_LOGITEC,
-		subvendor:   PCI_ANY_ID,
-		subdevice:   PCI_ANY_ID,
-		driver_data: MODEL_EXT_ROM,
-	},
-	{
-		vendor:      PCI_VENDOR_ID_WORKBIT,
-		device:      PCI_DEVICE_ID_NINJASCSI_32BIB_LOGITEC,
-		subvendor:   PCI_ANY_ID,
-		subdevice:   PCI_ANY_ID,
-		driver_data: MODEL_PCI_LOGITEC,
-	},
-	{
-		vendor:      PCI_VENDOR_ID_WORKBIT,
-		device:      PCI_DEVICE_ID_NINJASCSI_32UDE_MELCO,
-		subvendor:   PCI_ANY_ID,
-		subdevice:   PCI_ANY_ID,
-		driver_data: MODEL_PCI_MELCO,
-	},
-	{0,0,},
-};
-MODULE_DEVICE_TABLE(pci, nsp32_pci_table);
+		/* reset SACK/SavedACK counter (or ALL clear?) */
+		nsp32_write4(base, CLR_COUNTER, CLRCOUNTER_ALLMASK);
 
-static struct pci_driver nsp32_driver = {
-	.name =		"nsp32",
-	.id_table =	nsp32_pci_table,
-	.probe =	nsp32_probe,
-	.remove =	__devexit_p(nsp32_remove),
-#ifdef CONFIG_PM
-/*	.suspend =	nsp32_suspend,*/
-/*	.resume =	nsp32_resume,*/
-#endif
-};
+		/*
+		 * set new sg pointer
+		 */
+		new_sgtp = data->cur_lunt->sglun_paddr + 
+			(data->cur_lunt->cur_entry * sizeof(nsp32_sgtable));
+		nsp32_write4(base, SGT_ADR, new_sgtp);
 
-static int __init init_nsp32(void) {
-	return pci_module_init(&nsp32_driver);
-}
+		break;
 
-static void __exit exit_nsp32(void) {
-	pci_unregister_driver(&nsp32_driver);
-}
+	case SAVE_POINTERS:
+		/*
+		 * These messages should not be occurred.
+		 * They should be processed on AutoSCSI sequencer.
+		 */
+		nsp32_msg (KERN_WARNING, 
+			   "unexpected message of AutoSCSI MsgIn: SAVE_POINTERS");
+		
+		break;
+		
+	case MESSAGE_REJECT:
+		/* If previous message_out is sending SDTR, and get 
+		   message_reject from target, SDTR negotiation is failed */
+		if (data->cur_target->sync_flag &
+				(SDTR_INITIATOR | SDTR_TARGET)) {
+			/*
+			 * Current target is negotiating SDTR, but it's
+			 * failed.  Fall back to async transfer mode, and set
+			 * SDTR_DONE.
+			 */
+			nsp32_set_async(data, data->cur_target);
+			data->cur_target->sync_flag &= ~SDTR_INITIATOR;
+			data->cur_target->sync_flag |= SDTR_DONE;
 
-module_init(init_nsp32);
-module_exit(exit_nsp32);
+		}
+		break;
 
+	case LINKED_CMD_COMPLETE:
+	case LINKED_FLG_CMD_COMPLETE:
+		/* queue tag is not supported currently */
+		nsp32_msg (KERN_WARNING, 
+			   "unsupported message: 0x%x", msgtype);
+		break;
 
-/*
- * Reset parameters and call scsi_done for data->curlunt.
- * Be careful setting SCpnt->result = DID_* before calling this function.
- */
-static void nsp32_scsi_done(nsp32_hw_data *data, Scsi_Cmnd *SCpnt)
-{
-	unsigned int base = data->BaseAddress;
+	case INITIATE_RECOVERY:
+		/* staring ECA (Extended Contingent Allegiance) state. */
+		/* This message is declined in SPI2 or later. */
+
+		goto reject;
 
 	/*
-	 * unmap pci
+	 * 2-byte message
 	 */
-	if (SCpnt->request_bufflen == 0) {
-		goto skip;
+	case SIMPLE_QUEUE_TAG:
+	case 0x23:
+		/*
+		 * 0x23: Ignore_Wide_Residue is not declared in scsi.h.
+		 * No support is needed.
+		 */
+		if (data->msgin_len >= 1) {
+			goto reject;
+		}
+
+		/* current position is 1-byte of 2 byte */
+		msgclear = FALSE;
+
+		break;
+
+	/*
+	 * extended message
+	 */
+	case EXTENDED_MESSAGE:
+		if (data->msgin_len < 1) {
+			/*
+			 * Current position does not reach 2-byte
+			 * (2-byte is extended message length).
+			 */
+			msgclear = FALSE;
+			break;
+		}
+
+		if ((data->msginbuf[1] + 1) > data->msgin_len) {
+			/*
+			 * Current extended message has msginbuf[1] + 2
+			 * (msgin_len starts counting from 0, so buf[1] + 1).
+			 * If current message position is not finished,
+			 * continue receiving message.
+			 */
+			msgclear = FALSE;
+			break;
+		}
+
+		/*
+		 * Reach here means regular length of each type of 
+		 * extended messages.
+		 */
+		switch (data->msginbuf[2]) {
+		case EXTENDED_MODIFY_DATA_POINTER:
+			/* TODO */
+			goto reject; /* not implemented yet */
+			break;
+
+		case EXTENDED_SDTR:
+			/*
+			 * Exchange this message between initiator and target.
+			 */
+			if (data->msgin_len != EXTENDED_SDTR_LEN + 1) {
+				/*
+				 * received inappropriate message.
+				 */
+				goto reject;
+				break;
+			}
+
+			nsp32_analyze_sdtr(SCpnt);
+
+			break;
+
+		case EXTENDED_EXTENDED_IDENTIFY:
+			/* SCSI-I only, not supported. */
+			goto reject; /* not implemented yet */
+
+			break;
+
+		case EXTENDED_WDTR:
+			goto reject; /* not implemented yet */
+
+			break;
+			
+		default:
+			goto reject;
+		}
+		break;
+		
+	default:
+		goto reject;
 	}
 
-	if (SCpnt->use_sg) {
-		pci_unmap_sg(data->Pci,
-			(struct scatterlist *)SCpnt->buffer,
-			SCpnt->use_sg,
-			scsi_to_pci_dma_dir(SCpnt->sc_data_direction));
+ restart:
+	if (msgclear == TRUE) {
+		data->msgin_len = 0;
+
+		/*
+		 * If restarting AutoSCSI, but there are some message to out
+		 * (msgout_len > 0), set AutoATN, and set SCSIMSGOUT as 0
+		 * (MSGOUT_VALID = 0). When commandcontrol is written with
+		 * AutoSCSI restart, at the same time MsgOutOccur should be
+		 * happened (however, such situation is really possible...?).
+		 */
+		if (data->msgout_len > 0) {	
+			nsp32_write4(base, SCSI_MSG_OUT, 0);
+			command |= AUTO_ATN;
+		}
+
+		/*
+		 * restart AutoSCSI
+		 * If it's failed, COMMANDCONTROL_AUTO_COMMAND_PHASE is needed.
+		 */
+		command |= (AUTO_MSGIN_00_OR_04 | AUTO_MSGIN_02);
+
+		/*
+		 * If current msgin03 is TRUE, then flag on.
+		 */
+		if (data->cur_lunt->msgin03 == TRUE) {
+			command |= AUTO_MSGIN_03;
+		}
+		data->cur_lunt->msgin03 = FALSE;
 	} else {
-		pci_unmap_single(data->Pci,
-			(u32)SCpnt->SCp.have_data_in,
-			SCpnt->request_bufflen,
-			scsi_to_pci_dma_dir(SCpnt->sc_data_direction));
+		data->msgin_len++;
 	}
 
- skip:
 	/*
-	 * clear TRANSFERCONTROL_BM_START
+	 * restart AutoSCSI
 	 */
-	nsp32_write2(base, TRANSFER_CONTROL, 0);
-	nsp32_write4(base, BM_CNT, 0);
+	nsp32_restart_autoscsi(SCpnt, command);
 
 	/*
-	 * call scsi_done
+	 * wait SCSI REQ negate for REQ-ACK handshake
 	 */
-	(*SCpnt->scsi_done)(SCpnt);
+	nsp32_wait_req(data, NEGATE);
 
 	/*
-	 * reset parameters
+	 * negate SCSI ACK
 	 */
-	data->curlunt->SCpnt = NULL;
-	data->curlunt = NULL;
-	data->curtarget = NULL;
-	data->CurrentSC = NULL;
-}
+	nsp32_sack_negate(data);
+
+	nsp32_dbg(NSP32_DEBUG_MSGINOCCUR, "exit");
+
+	return;
+
+ reject:
+	nsp32_msg(KERN_WARNING, 
+		  "invalid or unsupported MessageIn, rejected. "
+		  "current msg: 0x%x (len: 0x%x), processing msg: 0x%x",
+		  msg, data->msgin_len, msgtype);
+	nsp32_build_reject(SCpnt);
+	data->msgin_len = 0;
 
+	goto restart;
+}
 
 /*
- * Bus Free Occur
- *
- * Current Phase is BUSFREE. AutoSCSI is automatically execute BUSFREE phase
- * with ACK reply when below condition is matched:
- *	MsgIn 00: Command Complete.
- *	MsgIn 02: Save Data Pointer.
- *	MsgIn 04: Diconnect.
- * In other case, unexpected BUSFREE is detected.
+ * 
  */
-static int nsp32_busfree_occur(nsp32_hw_data *data, unsigned short execph)
+static void nsp32_analyze_sdtr(Scsi_Cmnd *SCpnt)
 {
-	Scsi_Cmnd *SCpnt = data->curlunt->SCpnt;
-	unsigned int base = data->BaseAddress;
+	nsp32_hw_data   *data = (nsp32_hw_data *)SCpnt->device->host->hostdata;
+	nsp32_target     *target     = data->cur_target;
+	nsp32_sync_table *synct;
+	unsigned char     get_period = data->msginbuf[3];
+	unsigned char     get_offset = data->msginbuf[4];
+	int               entry;
+	int               syncnum;
 
-	nsp32_dbg(NSP32_DEBUG_BUSFREE, "enter");
+	nsp32_dbg(NSP32_DEBUG_MSGINOCCUR, "enter");
 
-	nsp32_write4(base, BM_CNT, 0);
-	nsp32_write2(base, TRANSFER_CONTROL, 0);
+	synct   = data->synct;
+	syncnum = data->syncnum;
 
 	/*
-	 * MsgIn 02: Save Data Pointer
-	 *
-	 * VALID:
-	 *   Save Data Pointer is received. Adjust pointer.
-	 *   
-	 * NO-VALID:
-	 *   SCSI-3 says if Save Data Pointer is not received, then we restart
-	 *   processing and we can't adjust any SCSI data pointer in next data
-	 *   phase.
-	 */
-	if (execph & MSGIN_02_VALID) {
-		nsp32_dbg(NSP32_DEBUG_BUSFREE, "MsgIn02_Valid");
-
+	 * If this inititor sent the SDTR message, then target responds SDTR,
+	 * initiator SYNCREG, ACKWIDTH from SDTR parameter.
+	 * Messages are not appropriate, then send back reject message.
+	 * If initiator did not send the SDTR, but target sends SDTR, 
+	 * initiator calculator the appropriate parameter and send back SDTR.
+	 */	
+	if (target->sync_flag & SDTR_INITIATOR) {
 		/*
-		 * Check sack_cnt/saved_sack_cnt, then adjust sg table if
-		 * needed.
+		 * Initiator sent SDTR, the target responds and
+		 * send back negotiation SDTR.
 		 */
-		if (!(execph & MSGIN_00_VALID) && 
-		    ((execph & DATA_IN_PHASE) || (execph & DATA_OUT_PHASE))) {
-			unsigned int sacklen, s_sacklen;
+		nsp32_dbg(NSP32_DEBUG_MSGINOCCUR, "target responds SDTR");
+	
+		target->sync_flag &= ~SDTR_INITIATOR;
+		target->sync_flag |= SDTR_DONE;
 
+		/*
+		 * offset:
+		 */
+		if (get_offset > MAX_OFFSET) {
 			/*
-			 * Read SACK count and SAVEDSACK count, then compare.
+			 * Negotiation is failed, the target send back
+			 * unexpected offset value.
 			 */
-			sacklen   = nsp32_read4(base, SACK_CNT);
-			s_sacklen = nsp32_read4(base, SAVED_SACK_CNT);
+			goto reject;
+		}
+		
+		if (get_offset == ASYNC_OFFSET) {
+			/*
+			 * Negotiation is succeeded, the target want
+			 * to fall back into asynchronous transfer mode.
+			 */
+			goto async;
+		}
 
+		/*
+		 * period:
+		 *    Check whether sync period is too short. If too short,
+		 *    fall back to async mode. If it's ok, then investigate
+		 *    the received sync period. If sync period is acceptable
+		 *    between sync table start_period and end_period, then
+		 *    set this I_T nexus as sent offset and period.
+		 *    If it's not acceptable, send back reject and fall back
+		 *    to async mode.
+		 */
+		if (get_period < data->synct[0].period_num) {
 			/*
-			 * If SAVEDSACKCNT == 0, it means SavedDataPointer is
-			 * come after data transfering.
+			 * Negotiation is failed, the target send back
+			 * unexpected period value.
 			 */
-			if (s_sacklen > 0) {
-				/*
-				 * Comparing between sack and savedsack to
-				 * check the condition of AutoMsgIn03.
-				 *
-				 * If they are same, set msgin03 == TRUE,
-				 * COMMANDCONTROL_AUTO_MSGIN_03 is enabled at
-				 * reselection.  On the other hand, if they
-				 * aren't same, set msgin03 == FALSE, and
-				 * COMMANDCONTROL_AUTO_MSGIN_03 is disabled at
-				 * reselection.
-				 */
-				if (sacklen != s_sacklen) {
-					data->curlunt->msgin03 = FALSE;
-				} else {
-					data->curlunt->msgin03 = TRUE;
-				}
+			goto reject;
+		}
 
-				nsp32_adjust_busfree(data, s_sacklen);
-			}
+		entry = nsp32_search_period_entry(data, target, get_period);
+
+		if (entry < 0) {
+			/*
+			 * Target want to use long period which is not 
+			 * acceptable NinjaSCSI-32Bi/UDE.
+			 */
+			goto reject;
 		}
 
-		/* This value has not substitude with valid value yet... */
-		//data->curlunt->save_datp = data->cur_datp;
-	} else {
 		/*
-		 * no processing.
+		 * Set new sync table and offset in this I_T nexus.
 		 */
-	}
+		nsp32_set_sync_entry(data, target, entry, get_offset);
+	} else {
+		/* Target send SDTR to initiator. */
+		nsp32_dbg(NSP32_DEBUG_MSGINOCCUR, "target send SDTR");
 	
-	if (execph & MSGIN_03_VALID) {
-		/* MsgIn03 was valid to be processed. No need processing. */
-	}
+		target->sync_flag |= SDTR_INITIATOR;
 
-	/*
-	 * target SDTR check
-	 */
-	if (data->curtarget->sync_flag & SDTR_INITIATOR) {
-		/*
-		 * SDTR negotiation pulled by the initiator has not
-		 * finished yet. Fall back to ASYNC mode.
-		 */
-		nsp32_set_async(data, data->curtarget);
-		data->curtarget->sync_flag &= ~SDTR_INITIATOR;
-		data->curtarget->sync_flag |= SDTR_DONE;
-	} else if (data->curtarget->sync_flag & SDTR_TARGET) {
-		/*
-		 * SDTR negotiation pulled by the target has been
-		 * negotiating.
-		 */
-		if (execph & (MSGIN_00_VALID | MSGIN_04_VALID)) {
-			/* 
-			 * If valid message is received, then
-			 * negotiation is succeeded.
-			 */
+		/* offset: */
+		if (get_offset > MAX_OFFSET) {
+			/* send back as MAX_OFFSET */
+			get_offset = MAX_OFFSET;
+		}
+
+		/* period: */
+		if (get_period < data->synct[0].period_num) {
+			get_period = data->synct[0].period_num;
+		}
+
+		entry = nsp32_search_period_entry(data, target, get_period);
+
+		if (get_offset == ASYNC_OFFSET || entry < 0) {
+			nsp32_set_async(data, target);
+			nsp32_build_sdtr(SCpnt, 0, ASYNC_OFFSET);
 		} else {
-			/*
-			 * On the contrary, if unexpected bus free is
-			 * occured, then negotiation is failed. Fall
-			 * back to ASYNC mode.
-			 */
-			nsp32_set_async(data, data->curtarget);
+			nsp32_set_sync_entry(data, target, entry, get_offset);
+			nsp32_build_sdtr(SCpnt, get_period, get_offset);
 		}
-		data->curtarget->sync_flag &= ~SDTR_TARGET;
-		data->curtarget->sync_flag |= SDTR_DONE;
 	}
-	
+
+	target->period = get_period;
+	nsp32_dbg(NSP32_DEBUG_MSGINOCCUR, "exit");
+	return;
+
+ reject:
 	/*
-	 * It is always ensured by SCSI standard that initiator
-	 * switches into Bus Free Phase after
-	 * receiving message 00 (Command Complete), 04 (Disconnect).
-	 * It's the reason that processing here is valid.
+	 * If the current message is unacceptable, send back to the target
+	 * with reject message.
 	 */
-	if (execph & MSGIN_00_VALID) {
-		/* MsgIn 00: Command Complete */
-		nsp32_dbg(NSP32_DEBUG_BUSFREE, "command complete");
+	nsp32_build_reject(SCpnt);
 
-		SCpnt->SCp.Status  = nsp32_read1(base, SCSI_CSB_IN);
-		SCpnt->SCp.Message = 0;
-		nsp32_dbg(NSP32_DEBUG_BUSFREE, 
-			  "normal end stat=0x%x resid=0x%x\n",
-			  SCpnt->SCp.Status, SCpnt->resid);
-		SCpnt->result = 
-			(DID_OK << 16) | (SCpnt->SCp.Message << 8) | (SCpnt->SCp.Status << 0);
-		nsp32_scsi_done(data, SCpnt);
-		/* All operation is done */
-		return (TRUE);
-	} else if (execph & MSGIN_04_VALID) {
-		/* MsgIn 04: Disconnect */
-		SCpnt->SCp.Status  = nsp32_read1(base, SCSI_CSB_IN);
-		SCpnt->SCp.Message = 4;
-		
-		nsp32_dbg(NSP32_DEBUG_BUSFREE, "disconnect");
-		return (TRUE);
-	} else {
-		/* Unexpected bus free */
-		nsp32_msg(KERN_WARNING, "unexpected bus free occured");
+ async:
+	nsp32_set_async(data, target);	/* set as ASYNC transfer mode */
 
-		/* DID_ERROR? */
-		//SCpnt->result   = (DID_OK << 16) | (SCpnt->SCp.Message << 8) | (SCpnt->SCp.Status << 0);
-		SCpnt->result = DID_ERROR << 16;
-		nsp32_scsi_done(data, SCpnt);
-		return (TRUE);
-	}
-	return (FALSE);
+	target->period = 0;
+	nsp32_dbg(NSP32_DEBUG_MSGINOCCUR, "exit: set async");
+	return;
 }
 
 
 /*
- * nsp32_adjust_busfree - adjusting SG table
- *
- * Note: This driver adjust the SG table using SCSI ACK
- *       counter instead of BMCNT counter!
+ * Search config entry number matched in sync_table from given
+ * target and speed period value. If failed to search, return negative value.
  */
-static void nsp32_adjust_busfree(nsp32_hw_data *data, unsigned int s_sacklen)
+static int nsp32_search_period_entry(nsp32_hw_data *data,
+				     nsp32_target  *target,
+				     unsigned char  period)
 {
-	int old_entry = data->cur_entry;
-	int new_entry;
-	struct nsp32_sgtable *sgt = data->curlunt->sglun->sgt;
-	unsigned int restlen, sentlen;
-	int sg_num = data->curlunt->sg_num;
+	int i;
 
-	/* adjust saved SACK count with 4 byte start address boundary */
-	s_sacklen -= sgt[old_entry].addr & 3;
+	if (target->limit_entry >= data->syncnum) {
+		nsp32_msg(KERN_ERR, "limit_entry exceeds syncnum!");
+		target->limit_entry = 0;
+	}
 
-	/*
-	 * calculate new_entry from sack count and each sgt[].len 
-	 * calculate the byte which is intent to send
-	 */
-	sentlen = 0;
-	for (new_entry = old_entry; new_entry < sg_num; new_entry++) {
-		sentlen += (sgt[new_entry].len & ~NSP32_SG_END_SGT);
-		if (sentlen > s_sacklen) {
-			break;
+	for (i = target->limit_entry; i < data->syncnum; i++) {
+		if (period >= data->synct[i].start_period &&
+		    period <= data->synct[i].end_period) {
+				break;
 		}
 	}
 
-	/* all sgt is processed */
-	if (new_entry == sg_num) {
-		goto last;
+	/*
+	 * Check given period value is over the sync_table value.
+	 * If so, return max value.
+	 */
+	if (i == data->syncnum) {
+		i = -1;
 	}
 
-	if (sentlen == s_sacklen) {
-		/* XXX: confirm it's ok or not */
-		/* In this case, it's ok because we are at 
-		   the head element of the sg. restlen is correctly calculated. */
-	}
+	return i;
+}
 
-	/* calculate the rest length for transfering */
-	restlen = sentlen - s_sacklen;
-	
-	/* update adjusting current SG table entry */
-	sgt[new_entry].addr += (sgt[new_entry].len - restlen);
-	sgt[new_entry].len = restlen;
 
-	/* set cur_entry with new_entry */
-	data->cur_entry = new_entry;
-	
-	return;
+/*
+ * target <-> initiator use ASYNC transfer
+ */
+static void nsp32_set_async(nsp32_hw_data *data, nsp32_target *target)
+{
+	unsigned char period = data->synct[target->limit_entry].period_num;
 
- last:
-	/* update hostdata and lun */
+	target->offset     = ASYNC_OFFSET;
+	target->period     = 0;
+	target->syncreg    = TO_SYNCREG(period, ASYNC_OFFSET);
+	target->ackwidth   = 0;
+	target->sample_reg = 0;
 
-	return;
+	nsp32_dbg(NSP32_DEBUG_SYNC, "set async");
 }
 
 
 /*
- * It's called MsgOut phase occur.
- * NinjaSCSI-32Bi/UDE automatically processes up to 3 messages in
- * message out phase. It, however, has more than 3 messages,
- * HBA creates the interrupt and we have to process by hand.
+ * target <-> initiator use maximum SYNC transfer
  */
-static void nsp32_msgout_occur(nsp32_hw_data *data)
+static void nsp32_set_max_sync(nsp32_hw_data *data,
+			       nsp32_target  *target,
+			       unsigned char *period,
+			       unsigned char *offset)
 {
-	unsigned int base = data->BaseAddress;
-	//unsigned short command;
-	long new_sgtp;
-	int i;
-	
-	nsp32_dbg(NSP32_DEBUG_MSGOUTOCCUR,
-		  "enter: msgoutlen: 0x%x", data->msgoutlen);
+	unsigned char period_num, ackwidth;
 
-	/*
-	 * If MsgOut phase is occured without having any
-	 * message, then No_Operation is sent (SCSI-2).
-	 */
-	if (data->msgoutlen == 0) {
-		nsp32_build_nop(data);
-	}
+	period_num = data->synct[target->limit_entry].period_num;
+	*period    = data->synct[target->limit_entry].start_period;
+	ackwidth   = data->synct[target->limit_entry].ackwidth;
+	*offset    = MAX_OFFSET;
 
-	/*
-	 * Set SGTP ADDR current entry for restarting AUTOSCSI, 
-	 * because SGTP is incremented next point.
-	 * There is few statement in the specification...
-	 */
- 	new_sgtp = data->curlunt->sglun_paddr
-		+ data->curlunt->cur_entry * sizeof(struct nsp32_sgtable);
+	target->syncreg    = TO_SYNCREG(period_num, *offset);
+	target->ackwidth   = ackwidth;
+	target->offset     = *offset;
+	target->sample_reg = 0;       /* disable SREQ sampling */
+}
 
-	/*
-	 * send messages
-	 */
-	for (i=0; i<data->msgoutlen; i++) {
-		nsp32_dbg(NSP32_DEBUG_MSGOUTOCCUR,
-			  "%d : 0x%x", i, data->msgoutbuf[i]);
 
-		/*
-		 * Check REQ is asserted.
-		 */
-		nsp32_wait_req(data, ASSERT);
+/*
+ * target <-> initiator use entry number speed
+ */
+static void nsp32_set_sync_entry(nsp32_hw_data *data,
+				 nsp32_target  *target,
+				 int            entry,
+				 unsigned char  offset)
+{
+	unsigned char period, ackwidth, sample_rate;
+
+	period      = data->synct[entry].period_num;
+	ackwidth    = data->synct[entry].ackwidth;
+	offset      = offset;
+	sample_rate = data->synct[entry].sample_rate;
+
+	target->syncreg    = TO_SYNCREG(period, offset);
+	target->ackwidth   = ackwidth;
+	target->offset     = offset;
+	target->sample_reg = sample_rate | SAMPLING_ENABLE;
 
-		if (i == (data->msgoutlen - 1)) {
-			/*
-			 * If the last message, set the AutoSCSI restart
-			 * before send back the ack message. AutoSCSI
-			 * restart automatically negate ATN signal.
-			 */
-			//command = (AUTO_MSGIN_00_OR_04 | AUTO_MSGIN_02);
-			//nsp32_restart_autoscsi(data, command);
-			nsp32_write2(base, COMMAND_CONTROL,
-					 (CLEAR_CDB_FIFO_POINTER |
-					  AUTO_COMMAND_PHASE |
-					  AUTOSCSI_RESTART |
-					  AUTO_MSGIN_00_OR_04 |
-					  AUTO_MSGIN_02 ));
-		}
-		/*
-		 * Write data with SACK, then wait sack is
-		 * automatically negated.
-		 */
-		nsp32_write1(base, SCSI_DATA_WITH_ACK, data->msgoutbuf[i]);
-		nsp32_wait_sack(data, NEGATE);
-
-		nsp32_dbg(NSP32_DEBUG_MSGOUTOCCUR, "bus: 0x%x\n",
-			  nsp32_read1(base, SCSI_BUS_MONITOR));
-	};
-
-	data->msgoutlen = 0;
-
-	nsp32_dbg(NSP32_DEBUG_MSGOUTOCCUR, "exit");
+	nsp32_dbg(NSP32_DEBUG_SYNC, "set sync");
 }
 
+
 /*
- * Restart AutoSCSI
+ * It waits until SCSI REQ becomes assertion or negation state.
  *
- * Note: Restarting AutoSCSI needs set:
- *		SYNC_REG, ACK_WIDTH, SGT_ADR, TRANSFER_CONTROL
+ * Note: If nsp32_msgin_occur is called, we asserts SCSI ACK. Then
+ *     connected target responds SCSI REQ negation.  We have to wait
+ *     SCSI REQ becomes negation in order to negate SCSI ACK signal for
+ *     REQ-ACK handshake.
  */
-static void nsp32_restart_autoscsi(nsp32_hw_data *data, unsigned short command)
+static void nsp32_wait_req(nsp32_hw_data *data, int state)
 {
-	unsigned int base = data->BaseAddress;
-	unsigned short transfer = 0;
-	Scsi_Cmnd *SCpnt = data->curlunt->SCpnt;
+	unsigned int  base      = data->BaseAddress;
+	int           wait_time = 0;
+	unsigned char bus, req_bit;
 
-	nsp32_dbg(NSP32_DEBUG_RESTART, "enter");
-
-	if (data->curtarget == NULL || data->curlunt == NULL) {
-		nsp32_msg(KERN_ERR, "Target or Lun is invalid");
+	if (!((state == ASSERT) || (state == NEGATE))) {
+		nsp32_msg(KERN_ERR, "unknown state designation");
 	}
+	/* REQ is BIT(5) */
+	req_bit = (state == ASSERT ? BUSMON_REQ : 0);
 
-	/*
-	 * set SYNC_REG
-	 * Don't set BM_START_ADR before setting this register.
-	 */
-	nsp32_write1(base, SYNC_REG, data->curtarget->syncreg);
-
-	/*
-	 * set ACKWIDTH
-	 */
-	nsp32_write1(base, ACK_WIDTH, data->curtarget->ackwidth);
-
-	/*
-	 * set SGT ADDR (physical address)
-	 */
-	nsp32_write4(base, SGT_ADR, data->curlunt->sglun_paddr);
-
-	/*
-	 * set TRANSFER CONTROL REG
-	 */
-	transfer = 0;
-	transfer |= (TRANSFER_GO | ALL_COUNTER_CLR);
-	if (data->trans_method & NSP32_TRANSFER_BUSMASTER) {
-		if (SCpnt->request_bufflen > 0) {
-			transfer |= BM_START;
+	do {
+		bus = nsp32_read1(base, SCSI_BUS_MONITOR);
+		if ((bus & BUSMON_REQ) == req_bit) {
+			nsp32_dbg(NSP32_DEBUG_WAIT, 
+				  "wait_time: %d", wait_time);
+			return;
 		}
-	} else if (data->trans_method & NSP32_TRANSFER_MMIO) {
-		transfer |= CB_MMIO_MODE;
-	} else if (data->trans_method & NSP32_TRANSFER_PIO) {
-		transfer |= CB_IO_MODE;
-	}
-	nsp32_write2(base, TRANSFER_CONTROL, transfer);
-
-	/*
-	 * restart AutoSCSI
-	 *
-	 * TODO: COMMANDCONTROL_AUTO_COMMAND_PHASE is needed ?
-	 */
-	command |= (CLEAR_CDB_FIFO_POINTER |
-		    AUTO_COMMAND_PHASE |
-		    AUTOSCSI_RESTART);
-	nsp32_write2(base, COMMAND_CONTROL, command);
+		udelay(1);
+		wait_time++;
+	} while (wait_time < REQSACK_TIMEOUT_TIME);
 
-	nsp32_dbg(NSP32_DEBUG_RESTART, "exit");
+	nsp32_msg(KERN_WARNING, "wait REQ timeout, req_bit: 0x%x", req_bit);
 }
 
-
 /*
- * cannot run automatically message in occur
+ * It waits until SCSI SACK becomes assertion or negation state.
  */
-static void nsp32_msgin_occur(nsp32_hw_data *data, unsigned long irq_status,
-			unsigned short execph)
+static void nsp32_wait_sack(nsp32_hw_data *data, int state)
 {
-	unsigned int base = data->BaseAddress;
-	unsigned char msg;
-	unsigned char msgtype;
-	unsigned char newlun;
-	unsigned short command = 0;
-	int msgclear = TRUE;
-	long new_sgtp;
-	int ret;
+	unsigned int  base      = data->BaseAddress;
+	int           wait_time = 0;
+	unsigned char bus, ack_bit;
 
-	/*
-	 * read first message
-	 *    Use SCSIDATA_W_ACK instead of SCSIDATAIN, because the procedure
-	 *    of Message-In have to be processed before sending back SCSI ACK.
-	 */
-	msg = nsp32_read1(base, SCSI_DATA_IN);
-	data->msginbuf[(unsigned char)data->msginlen] = msg;
-	msgtype = data->msginbuf[0];
-	nsp32_dbg(NSP32_DEBUG_MSGINOCCUR,
-		  "enter: msglen: 0x%x msgin: 0x%x msgtype: 0x%x",
-		  data->msginlen, msg, msgtype);
-
-	/*
-	 * TODO: We need checking whether bus phase is message in?
-	 */
-
-	/*
-	 * assert SCSI ACK
-	 */
-	nsp32_sack_assert(data);
-
-	/*
-	 * processing IDENTIFY
-	 */
-	if (msgtype & 0x80) {
-		if (!(irq_status & IRQSTATUS_RESELECT_OCCUER)) {
-			/* Invalid (non reselect) phase */
-			goto reject;
-		}
-
-		newlun = msgtype & 0x1f; /* TODO: SPI-3 compliant? */
-		ret = nsp32_reselection(data, newlun);
-		if (ret == TRUE) {
-			goto restart;
-		} else {
-			goto reject;
-		}
+	if (!((state == ASSERT) || (state == NEGATE))) {
+		nsp32_msg(KERN_ERR, "unknown state designation");
 	}
-	
-	/*
-	 * processing messages except for IDENTIFY
-	 *
-	 * TODO: Messages are all SCSI-2 terminology. SCSI-3 compliance is TODO.
-	 */
-	switch (msgtype) {
-	/*
-	 * 1-byte message
-	 */
-	case COMMAND_COMPLETE:
-	case DISCONNECT:
-		/*
-		 * These messages should not be occured.
-		 * They should be processed on AutoSCSI sequencer.
-		 */
-		nsp32_msg(KERN_WARNING, 
-			   "unexpected message of AutoSCSI MsgIn: 0x%x", msg);
-		break;
-		
-	case RESTORE_POINTERS:
-		/*
-		 * AutoMsgIn03 is disabled, and HBA gets this message.
-		 */
+	/* ACK is BIT(4) */
+	ack_bit = (state == ASSERT ? BUSMON_ACK : 0);
 
-		if ((execph & DATA_IN_PHASE) || (execph & DATA_OUT_PHASE)) {
-			unsigned int s_sacklen;
-
-			s_sacklen = nsp32_read4(base, SAVED_SACK_CNT);
-			if ((execph & MSGIN_02_VALID) && (s_sacklen > 0)) {
-				nsp32_adjust_busfree(data, s_sacklen);
-			} else {
-				/* No need to rewrite SGT */
-			}
+	do {
+		bus = nsp32_read1(base, SCSI_BUS_MONITOR);
+		if ((bus & BUSMON_ACK) == ack_bit) {
+			nsp32_dbg(NSP32_DEBUG_WAIT,
+				  "wait_time: %d", wait_time);
+			return;
 		}
-		data->curlunt->msgin03 = FALSE;
+		udelay(1);
+		wait_time++;
+	} while (wait_time < REQSACK_TIMEOUT_TIME);
 
-		/* Update with the new value */
+	nsp32_msg(KERN_WARNING, "wait SACK timeout, ack_bit: 0x%x", ack_bit);
+}
 
-		/* reset SACK/SavedACK counter (or ALL clear?) */
-		nsp32_write4(base, CLR_COUNTER, CLRCOUNTER_ALLMASK);
+/*
+ * assert SCSI ACK
+ *
+ * Note: SCSI ACK assertion needs with ACKENB=1, AUTODIRECTION=1.
+ */
+static void nsp32_sack_assert(nsp32_hw_data *data)
+{
+	unsigned int  base = data->BaseAddress;
+	unsigned char busctrl;
 
-		/*
-		 * set new sg pointer
-		 */
-		new_sgtp = data->curlunt->sglun_paddr + 
-			data->curlunt->cur_entry * sizeof(struct nsp32_sgtable);
-		nsp32_write4(base, SGT_ADR, new_sgtp);
+	busctrl  = nsp32_read1(base, SCSI_BUS_CONTROL);
+	busctrl	|= (BUSCTL_ACK | AUTODIRECTION | ACKENB);
+	nsp32_write1(base, SCSI_BUS_CONTROL, busctrl);
+}
 
-		break;
+/*
+ * negate SCSI ACK
+ */
+static void nsp32_sack_negate(nsp32_hw_data *data)
+{
+	unsigned int  base = data->BaseAddress;
+	unsigned char busctrl;
 
-	case SAVE_POINTERS:
-		/*
-		 * These messages should not be occured.
-		 * They should be processed on AutoSCSI sequencer.
-		 */
-		nsp32_msg (KERN_WARNING, 
-			   "unexpected message of AutoSCSI MsgIn: SAVE_POINTERS");
-		
-		break;
-		
-	case MESSAGE_REJECT:
-		/* If previous message_out is sending SDTR, and get 
-		   message_reject from target, SDTR negotiation is failed */
-		if (data->curtarget->sync_flag &
-				(SDTR_INITIATOR | SDTR_TARGET)) {
-			/*
-			 * Current target is negotiating SDTR, but it's
-			 * failed.  Fall back to async transfer mode, and set
-			 * SDTR_DONE.
-			 */
-			nsp32_set_async(data, data->curtarget);
-			data->curtarget->sync_flag &= ~SDTR_INITIATOR;
-			data->curtarget->sync_flag |= SDTR_DONE;
+	busctrl  = nsp32_read1(base, SCSI_BUS_CONTROL);
+	busctrl	&= ~BUSCTL_ACK;
+	nsp32_write1(base, SCSI_BUS_CONTROL, busctrl);
+}
 
-		}
-		break;
 
-	case LINKED_CMD_COMPLETE:
-	case LINKED_FLG_CMD_COMPLETE:
-		/* queue tag is not supported currently */
-		nsp32_msg (KERN_WARNING, 
-			   "unsupported message: 0x%x", msgtype);
-		break;
 
-	case INITIATE_RECOVERY:
-		/* staring ECA (Extended Contingent Allegiance) state. */
-		/* This message is declined in SPI2 or later. */
+/*
+ * Note: n_io_port is defined as 0x7f because I/O register port is
+ *	 assigned as:
+ *	0x800-0x8ff: memory mapped I/O port
+ *	0x900-0xbff: (map same 0x800-0x8ff I/O port image repeatedly)
+ *	0xc00-0xfff: CardBus status registers
+ */
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2,5,73))
+#define DETECT_OK 0
+#define DETECT_NG 1
+#define PCIDEV    pdev
+static int nsp32_detect(struct pci_dev *pdev)
+#else
+#define DETECT_OK 1
+#define DETECT_NG 0
+#define PCIDEV    (data->Pci)
+static int nsp32_detect(Scsi_Host_Template *sht)
+#endif
+{
+	struct Scsi_Host *host;	/* registered host structure */
+	struct resource  *res;
+	nsp32_hw_data    *data;
+	int               ret;
+	int               n_target, n_lun, i;
 
-		goto reject;
+	nsp32_dbg(NSP32_DEBUG_REGISTER, "enter");
 
 	/*
-	 * 2-byte message
+	 * register this HBA as SCSI device
 	 */
-	case SIMPLE_QUEUE_TAG:
-	case 0x23:
-		/*
-		 * 0x23: Ignore_Wide_Residue is not declared in scsi.h.
-		 * No support is needed.
-		 */
-		if (data->msginlen >= 1) {
-			goto reject;
-		}
-
-		/* current position is 1-byte of 2 byte */
-		msgclear = FALSE;
-
-		break;
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2,5,73))
+	host = scsi_host_alloc(&nsp32_template, sizeof(nsp32_hw_data));
+#else
+	host = scsi_register(sht, sizeof(nsp32_hw_data));
+#endif
+	if (host == NULL) {
+		nsp32_msg (KERN_ERR, "failed to scsi register");
+		goto err;
+	}
 
 	/*
-	 * extended message
+	 * set nsp32_hw_data
 	 */
-	case EXTENDED_MESSAGE:
-		if (data->msginlen < 1) {
-			/*
-			 * Current position does not reach 2-byte
-			 * (2-byte is extended message length).
-			 */
-			msgclear = FALSE;
-			break;
-		}
-
-		if ((data->msginbuf[1] + 1) > data->msginlen) {
-			/*
-			 * Current extended message has msginbuf[1] + 2
-			 * (msginlen starts counting from 0, so buf[1] + 1).
-			 * If current message position is not finished,
-			 * continue receiving message.
-			 */
-			msgclear = FALSE;
-			break;
-		}
-
-		/*
-		 * Reach here means regular length of each type of 
-		 * extended messages.
-		 */
-		switch (data->msginbuf[2]) {
-		case EXTENDED_MODIFY_DATA_POINTER:
-			/* TODO */
-			goto reject; /* not implemented yet */
-			break;
-
-		case EXTENDED_SDTR:
-			/*
-			 * Exchange this message between initiator and target.
-			 */
-			if (data->msginlen != EXTENDED_SDTR_LEN + 1) {
-				/*
-				 * received inappropriate message.
-				 */
-				goto reject;
-				break;
-			}
-
-			nsp32_analyze_sdtr(data);
-
-			break;
-
-		case EXTENDED_EXTENDED_IDENTIFY:
-			/* SCSI-I only, not supported. */
-			goto reject; /* not implemented yet */
-
-			break;
-
-		case EXTENDED_WDTR:
-			goto reject; /* not implemented yet */
-
-			break;
-			
-		default:
-			goto reject;
-		}
-		break;
-		
-	default:
-		goto reject;
-	}
-
- restart:
-	if (msgclear == TRUE) {
-		data->msginlen = 0;
-
-		/*
-		 * If restarting AutoSCSI, but there are some message to out
-		 * (msgoutlen > 0), set AutoATN, and set SCSIMSGOUT as 0
-		 * (MV_VALID = 0). When commandcontrol is written with
-		 * AutoSCSI restart, at the same time MsgOutOccur should be
-		 * happened (however, such situation is really possible...?).
-		 */
-		if (data->msgoutlen > 0) {	
-			nsp32_write4(base, SCSI_MSG_OUT, 0);
-			command |= AUTO_ATN;
-		}
+	data = (nsp32_hw_data *)host->hostdata;
 
-		/*
-		 * restart AutoSCSI
-		 * If it's failed, COMMANDCONTROL_AUTO_COMMAND_PHASE is needed.
-		 */
-		command |= (AUTO_MSGIN_00_OR_04 | AUTO_MSGIN_02);
+	*data = nsp32_data_base;
 
-		/*
-		 * If current msgin03 is TRUE, then flag on.
-		 */
-		if (data->curlunt->msgin03 == TRUE) {
-			command |= AUTO_MSGIN_03;
-		}
-		data->curlunt->msgin03 = FALSE;
-	} else {
-		data->msginlen++;
-	}
+	host->irq       = data->IrqNumber;
+	host->io_port   = data->BaseAddress;
+	host->unique_id = data->BaseAddress;
+	host->n_io_port	= data->NumAddress;
+	host->base      = data->MmioAddress;
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2,5,63))
+	scsi_set_device(host, &PCIDEV->dev);
+#else
+	scsi_set_pci_device(host, PCIDEV);
+#endif
+
+	data->Host      = host;
+	spin_lock_init(&(data->Lock));
+
+	data->cur_lunt   = NULL;
+	data->cur_target = NULL;
 
 	/*
-	 * restart AutoSCSI
+	 * Bus master transfer mode is supported currently.
 	 */
-	nsp32_restart_autoscsi(data, command);
+	data->trans_method = NSP32_TRANSFER_BUSMASTER;
 
 	/*
-	 * wait SCSI REQ negate for REQ-ACK handshake
+	 * Set clock div, CLOCK_4 (HBA has own external clock, and
+	 * dividing * 100ns/4).
+	 * Currently CLOCK_4 has only tested, not for CLOCK_2/PCICLK yet.
 	 */
-	nsp32_wait_req(data, NEGATE);
+	data->clock = CLOCK_4;
 
 	/*
-	 * negate SCSI ACK
+	 * Select appropriate nsp32_sync_table and set I_CLOCKDIV.
 	 */
-	nsp32_sack_negate(data);
-
-	nsp32_dbg(NSP32_DEBUG_MSGINOCCUR, "exit");
+	switch (data->clock) {
+	case CLOCK_4:
+		/* If data->clock is CLOCK_4, then select 40M sync table. */
+		data->synct   = nsp32_sync_table_40M;
+		data->syncnum = NUMBER(nsp32_sync_table_40M);
+		break;
+	case CLOCK_2:
+		/* If data->clock is CLOCK_2, then select 20M sync table. */
+		data->synct   = nsp32_sync_table_20M;
+		data->syncnum = NUMBER(nsp32_sync_table_20M);
+		break;
+	case PCICLK:
+		/* If data->clock is PCICLK, then select pci sync table. */
+		data->synct   = nsp32_sync_table_pci;
+		data->syncnum = NUMBER(nsp32_sync_table_pci);
+		break;
+	default:
+		nsp32_msg(KERN_WARNING,
+			  "Invalid clock div is selected, set CLOCK_4.");
+		/* Use default value CLOCK_4 */
+		data->clock   = CLOCK_4;
+		data->synct   = nsp32_sync_table_40M;
+		data->syncnum = NUMBER(nsp32_sync_table_40M);
+	}
 
-	return;
+	/*
+	 * setup nsp32_lunt
+	 */
 
- reject:
-	nsp32_msg(KERN_WARNING, 
-		  "invalid or unsupported MessageIn, rejected. "
-		  "current msg: 0x%x (len: 0x%x), processing msg: 0x%x",
-		  msg, data->msginlen, msgtype);
-	nsp32_build_reject(data);
-	data->msginlen = 0;
+	/*
+	 * setup DMA 
+	 */
+	if (pci_set_dma_mask(PCIDEV, 0xffffffffUL) != 0) {
+		nsp32_msg (KERN_ERR, "failed to set PCI DMA mask");
+		goto scsi_unregister;
+	}
 
-	goto restart;
-}
+	/*
+	 * allocate autoparam DMA resource.
+	 */
+	data->autoparam = pci_alloc_consistent(PCIDEV, sizeof(nsp32_autoparam), &(data->auto_paddr));
+	if (data->autoparam == NULL) {
+		nsp32_msg(KERN_ERR, "failed to allocate DMA memory");
+		goto scsi_unregister;
+	}
 
-/*
- * 
- */
-static void nsp32_analyze_sdtr(nsp32_hw_data *data)
-{
-	struct nsp32_target *target = data->curtarget;
-	struct nsp32_sync_table *synct;
-	unsigned char get_period = data->msginbuf[3];
-	unsigned char get_offset = data->msginbuf[4];
-	int entry;
-	int syncnum;
+	/*
+	 * allocate scatter-gather DMA resource.
+	 */
+	data->sg_list = pci_alloc_consistent(PCIDEV, NSP32_SG_TABLE_SIZE,
+					     &(data->sg_paddr));
+	if (data->sg_list == NULL) {
+		nsp32_msg(KERN_ERR, "failed to allocate DMA memory");
+		goto free_autoparam;
+	}
 
-	nsp32_dbg(NSP32_DEBUG_MSGINOCCUR, "enter");
+	for (n_target = 0; n_target < NUMBER(data->lunt); n_target++) {
+		for (n_lun = 0; n_lun < NUMBER(data->lunt[0]); n_lun++) {
+			int offset = n_target * NUMBER(data->lunt[0]) + n_lun;
+			nsp32_lunt tmp = {
+				SCpnt:       NULL,
+				save_datp:   0,
+				msgin03:     FALSE,
+				sg_num:      0,
+				cur_entry:   0,
+				sglun:       &(data->sg_list[offset]),
+				sglun_paddr: data->sg_paddr + ARRAY_OFFSET(nsp32_sglun, offset),
+			};
 
-	synct = data->synct;
-	syncnum = data->syncnum;
+			data->lunt[n_target][n_lun] = tmp;
+		}
+	}
 
 	/*
-	 * If this inititor sent the SDTR message, then target responds SDTR,
-	 * initiator SYNCREG, ACKWIDTH from SDTR parameter.
-	 * Messages are not appropriate, then send back reject message.
-	 * If initiator did not send the SDTR, but target sends SDTR, 
-	 * initiator calculator the appropriate parameter and send back SDTR.
-	 */	
-	if (target->sync_flag & SDTR_INITIATOR) {
-		/*
-		 * Initiator sent SDTR, the target responds and
-		 * send back negotiation SDTR.
-		 */
-		nsp32_dbg(NSP32_DEBUG_MSGINOCCUR, "target responds SDTR");
-	
-		target->sync_flag &= ~SDTR_INITIATOR;
-		target->sync_flag |= SDTR_DONE;
+	 * setup target
+	 */
+	for (i = 0; i < NUMBER(data->target); i++) {
+		nsp32_target *target = &(data->target[i]);
 
-		/*
-		 * offset:
-		 */
-		if (get_offset > SYNC_OFFSET) {
-			/*
-			 * Negotiation is failed, the target send back
-			 * unexpected offset value.
-			 */
-			goto reject;
-		}
-		
-		if (get_offset == ASYNC_OFFSET) {
-			/*
-			 * Negotiation is succeeded, the target want
-			 * to fall back into asynchronous transfer mode.
-			 */
-			goto async;
-		}
+		target->limit_entry  = 0;
+		target->sync_flag    = SDTR_NONE;
+		nsp32_set_async(data, target);
+	}
 
-		/*
-		 * period:
-		 *    Check whether sync period is too short. If too short,
-		 *    fall back to async mode. If it's ok, then investigate
-		 *    the received sync period. If sync period is acceptable
-		 *    between sync table start_period and end_period, then
-		 *    set this I_T nexus as sent offset and period.
-		 *    If it's not acceptable, send back reject and fall back
-		 *    to async mode.
-		 */
-		if (get_period < data->synct[0].period_num) {
-			/*
-			 * Negotiation is failed, the target send back
-			 * unexpected period value.
-			 */
-			goto reject;
-		}
+	/*
+	 * EEPROM check
+	 */
+	ret = nsp32_getprom_param(data);
+	if (ret == FALSE) {
+		data->resettime = 3;	/* default 3 */
+	}
 
-		entry = nsp32_search_period_entry(data, target, get_period);
+	/*
+	 * setup HBA
+	 */
+	nsp32hw_init(data);
 
-		if (entry < 0) {
-			/*
-			 * Target want to use long period which is not 
-			 * acceptable NinjaSCSI-32Bi/UDE.
-			 */
-			goto reject;
-		}
+	snprintf(data->info_str, sizeof(data->info_str),
+		 "NinjaSCSI-32Bi/UDE: irq %d, io 0x%lx+0x%x",
+		 host->irq, host->io_port, host->n_io_port);
 
-		/*
-		 * Set new sync table and offset in this I_T nexus.
-		 */
-		nsp32_set_sync_entry(data, target, entry, get_offset);
-	} else {
-		/* Target send SDTR to initiator. */
-		nsp32_dbg(NSP32_DEBUG_MSGINOCCUR, "target send SDTR");
-	
-		target->sync_flag |= SDTR_INITIATOR;
+	/*
+	 * SCSI bus reset
+	 *
+	 * Note: It's important to reset SCSI bus in initialization phase.
+	 *     NinjaSCSI-32Bi/UDE HBA EEPROM seems to exchange SDTR when
+	 *     system is coming up, so SCSI devices connected to HBA is set as
+	 *     un-asynchronous mode.  It brings the merit that this HBA is
+	 *     ready to start synchronous transfer without any preparation,
+	 *     but we are difficult to control transfer speed.  In addition,
+	 *     it prevents device transfer speed from effecting EEPROM start-up
+	 *     SDTR.  NinjaSCSI-32Bi/UDE has the feature if EEPROM is set as
+	 *     Auto Mode, then FAST-10M is selected when SCSI devices are
+	 *     connected same or more than 4 devices.  It should be avoided
+	 *     depending on this specification. Thus, resetting the SCSI bus
+	 *     restores all connected SCSI devices to asynchronous mode, then
+	 *     this driver set SDTR safely later, and we can control all SCSI
+	 *     device transfer mode.
+	 */
+	nsp32_do_bus_reset(data);
 
-		/* offset: */
-		if (get_offset > SYNC_OFFSET) {
-			/* send back as SYNC_OFFSET */
-			get_offset = SYNC_OFFSET;
-		}
+	ret = request_irq(host->irq, do_nsp32_isr,
+			  SA_SHIRQ | SA_SAMPLE_RANDOM, "nsp32", data);
+	if (ret < 0) {
+		nsp32_msg(KERN_ERR, "Unable to allocate IRQ for NinjaSCSI32 "
+			  "SCSI PCI controller. Interrupt: %d", host->irq);
+		goto free_sg_list;
+	}
 
-		/* period: */
-		if (get_period < data->synct[0].period_num) {
-			get_period = data->synct[0].period_num;
-		}
+        /*
+         * PCI IO register
+         */
+	res = request_region(host->io_port, host->n_io_port, "nsp32");
+	if (res == NULL) {
+		nsp32_msg(KERN_ERR, 
+			  "I/O region 0x%lx+0x%lx is already used",
+			  data->BaseAddress, data->NumAddress);
+		goto free_irq;
+        }
 
-		entry = nsp32_search_period_entry(data, target, get_period);
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2,5,73))
+	scsi_add_host (host, &PCIDEV->dev);
+	scsi_scan_host(host);
+#endif
+	pci_set_drvdata(PCIDEV, host);
+	return DETECT_OK;
 
-		if (get_offset == ASYNC_OFFSET || entry < 0) {
-			nsp32_set_async(data, target);
-			nsp32_build_sdtr(data, 0, ASYNC_OFFSET);
-		} else {
-			nsp32_set_sync_entry(data, target, entry, get_offset);
-			nsp32_build_sdtr(data, get_period, get_offset);
-		}
-	}
-	
-	nsp32_dbg(NSP32_DEBUG_MSGINOCCUR, "exit");
-	return;
+ free_irq:
+	free_irq(host->irq, data);
 
- reject:
-	/*
-	 * If the current message is unacceptable, send back to the target
-	 * with reject message.
-	 */
-	nsp32_build_reject(data);
+ free_sg_list:
+	pci_free_consistent(PCIDEV, NSP32_SG_TABLE_SIZE,
+			    data->sg_list, data->sg_paddr);
 
- async:
-	nsp32_set_async(data, target);	/* set as ASYNC transfer mode */
+ free_autoparam:
+	pci_free_consistent(PCIDEV, sizeof(nsp32_autoparam),
+			    data->autoparam, data->auto_paddr);
+	
+ scsi_unregister:
+	scsi_host_put(host);
 
-	nsp32_dbg(NSP32_DEBUG_MSGINOCCUR, "exit: set async");
-	return;
+ err:
+	return DETECT_NG;
 }
+#undef DETECT_OK
+#undef DETECT_NG
+#undef PCIDEV
 
-
-/*
- * Search config entry number matched in sync_table from given
- * target and speed period value. If failed to search, return negative value.
- */
-static int nsp32_search_period_entry(nsp32_hw_data *data,
-			      struct nsp32_target *target,
-			      unsigned char period)
+static int nsp32_release(struct Scsi_Host *host)
 {
-	int i;
+	nsp32_hw_data *data = (nsp32_hw_data *)host->hostdata;
 
-	if (target->limit_entry >= data->syncnum) {
-		nsp32_msg(KERN_ERR, "limit_entry exceeds syncnum!");
-		target->limit_entry = 0;
+	if (data->autoparam) {
+		pci_free_consistent(data->Pci, sizeof(nsp32_autoparam),
+				    data->autoparam, data->auto_paddr);
 	}
 
-	for (i=target->limit_entry; i<data->syncnum; i++) {
-		if (period >= data->synct[i].start_period &&
-		    period <= data->synct[i].end_period) {
-				break;
-		}
+	if (data->sg_list) {
+		pci_free_consistent(data->Pci, NSP32_SG_TABLE_SIZE,
+				    data->sg_list, data->sg_paddr);
 	}
 
-	/*
-	 * Check given period value is over the sync_table value.
-	 * If so, return max value.
-	 */
-	if (i == data->syncnum) {
-		i = -1;
+	if (host->irq) {
+		free_irq(host->irq, data);
 	}
 
-	return i;
-}
-
-
-/*
- * target <-> initiator use ASYNC transfer
- */
-static void nsp32_set_async(nsp32_hw_data *data, struct nsp32_target *target)
-{
-	unsigned char period = data->synct[target->limit_entry].period_num;
+	if (host->io_port && host->n_io_port) {
+		release_region(host->io_port, host->n_io_port);
+	}
 
-	target->offset   = ASYNC_OFFSET;
-	target->syncreg  = TO_SYNCREG(period, ASYNC_OFFSET);
-	target->ackwidth = 0;
+	if (data->MmioAddress != 0) {
+		iounmap((void *)(data->MmioAddress));
+	}
 
-	nsp32_dbg(NSP32_DEBUG_SYNC, "set async");
+	return 0;
 }
 
+static const char *nsp32_info(struct Scsi_Host *shpnt)
+{
+	nsp32_hw_data *data = (nsp32_hw_data *)shpnt->hostdata;
 
-/*
- * target <-> initiator use maximum SYNC transfer
- */
-static void nsp32_set_max_sync(nsp32_hw_data *data,
-			       struct nsp32_target *target,
-			       unsigned char *period, unsigned char *offset)
-{
-	unsigned char period_num, ackwidth;
-
-	period_num = data->synct[target->limit_entry].period_num;
-	*period    = data->synct[target->limit_entry].start_period;
-	ackwidth   = data->synct[target->limit_entry].ackwidth;
-	*offset    = SYNC_OFFSET;
-
-	target->syncreg  = TO_SYNCREG(period_num, *offset);
-	target->ackwidth = ackwidth;
-	target->offset   = *offset;
+	return data->info_str;
 }
 
 
-/*
- * target <-> initiator use entry number speed
+/****************************************************************************
+ * error handler
  */
-static void nsp32_set_sync_entry(nsp32_hw_data *data,
-				 struct nsp32_target *target,
-				 int entry, unsigned char offset)
+static int nsp32_eh_abort(Scsi_Cmnd *SCpnt)
 {
-	unsigned char period, ackwidth;
+	nsp32_hw_data *data = (nsp32_hw_data *)SCpnt->device->host->hostdata;
+	unsigned int   base = SCpnt->device->host->io_port;
 
-	period   = data->synct[entry].period_num;
-	ackwidth = data->synct[entry].ackwidth;
-	offset  = offset;
-
-	target->syncreg  = TO_SYNCREG(period, offset);
-	target->ackwidth = ackwidth;
-	target->offset   = offset;
+	nsp32_msg(KERN_WARNING, "abort");
 
-	nsp32_dbg(NSP32_DEBUG_SYNC, "set sync");
-}
+	if (data->cur_lunt->SCpnt == NULL) {
+		nsp32_dbg(NSP32_DEBUG_BUSRESET, "abort failed");
+		return FAILED;
+	}
 
+	if (data->cur_target->sync_flag & (SDTR_INITIATOR | SDTR_TARGET)) {
+		/* reset SDTR negotiation */
+		data->cur_target->sync_flag = SDTR_NONE;
+		nsp32_set_async(data, data->cur_target);
+	}
 
-/*
- * It waits until SCSI REQ becomes assertion or negation state.
- *
- * Note: If nsp32_msgin_occur is called, we asserts SCSI ACK. Then
- *     connected target responds SCSI REQ negation.  We have to wait
- *     SCSI REQ becomes negation in order to negate SCSI ACK signal for
- *     REQ-ACK handshake.
- */
-static void nsp32_wait_req(nsp32_hw_data *data, int state)
+	nsp32_write2(base, TRANSFER_CONTROL, 0);
+	nsp32_write2(base, BM_CNT,           0);
+
+	SCpnt->result = DID_ABORT << 16;
+	nsp32_scsi_done(SCpnt);
+
+	nsp32_dbg(NSP32_DEBUG_BUSRESET, "abort success");
+	return SUCCESS;
+}
+
+static int nsp32_eh_bus_reset(Scsi_Cmnd *SCpnt)
 {
-	unsigned int base = data->BaseAddress;
-	int wait_time = 0;
-	unsigned char bus;
+	nsp32_hw_data *data = (nsp32_hw_data *)SCpnt->device->host->hostdata;
+	unsigned int   base = SCpnt->device->host->io_port;
 
-	if (!((state == ASSERT) || (state == NEGATE))) {
-		nsp32_msg(KERN_ERR, "unknown state designation");
-	}
-	state <<= 5; /* REQ is BIT(5) */
+	nsp32_msg(KERN_INFO, "Bus Reset");	
+	nsp32_dbg(NSP32_DEBUG_BUSRESET, "SCpnt=0x%x", SCpnt);
 
-	do {
-		bus = nsp32_read1(base, SCSI_BUS_MONITOR);
-		if ((bus & BUSMON_REQ) == state) {
-			nsp32_dbg(NSP32_DEBUG_WAIT, 
-				  "wait_time: %d", wait_time);
-			return;
-		}
-		udelay(1);
-		wait_time++;
-	} while (wait_time < REQSACK_TIMEOUT_TIME);
+	nsp32_write2(base, IRQ_CONTROL, IRQ_CONTROL_ALL_IRQ_MASK);
+	nsp32_do_bus_reset(data);
+	nsp32_write2(base, IRQ_CONTROL, 0);
 
-	nsp32_msg(KERN_WARNING, "wait REQ timeout, state: %d", state);
+	return SUCCESS;	/* SCSI bus reset is succeeded at any time. */
 }
 
-/*
- * It waits until SCSI SACK becomes assertion or negation state.
- */
-static void nsp32_wait_sack(nsp32_hw_data *data, int state)
+static void nsp32_do_bus_reset(nsp32_hw_data *data)
 {
-	unsigned int base = data->BaseAddress;
-	int wait_time = 0;
-	unsigned char bus;
+	unsigned int   base = data->BaseAddress;
+	unsigned short intrdat;
+	int i;
 
-	if (!((state == ASSERT) || (state == NEGATE))) {
-		nsp32_msg(KERN_ERR, "unknown state designation");
+	nsp32_dbg(NSP32_DEBUG_BUSRESET, "in");
+
+	/*
+	 * stop all transfer
+	 * clear TRANSFERCONTROL_BM_START
+	 * clear counter
+	 */
+	nsp32_write2(base, TRANSFER_CONTROL, 0);
+	nsp32_write4(base, BM_CNT,           0);
+	nsp32_write4(base, CLR_COUNTER,      CLRCOUNTER_ALLMASK);
+
+	/*
+	 * fall back to asynchronous transfer mode
+	 * initialize SDTR negotiation flag
+	 */
+	for (i = 0; i < NUMBER(data->target); i++) {
+		nsp32_target *target = &data->target[i];
+
+		target->sync_flag = SDTR_NONE;
+		nsp32_set_async(data, target);
 	}
-	state <<= 4; /* ACK is BIT(4) */
 
-	do {
-		bus = nsp32_read1(base, SCSI_BUS_MONITOR);
-		if ((bus & BUSMON_ACK) == state) {
-			nsp32_dbg(NSP32_DEBUG_WAIT,
-				  "wait_time: %d", wait_time);
-			return;
-		}
-		udelay(1);
-		wait_time++;
-	} while (wait_time < REQSACK_TIMEOUT_TIME);
+	/*
+	 * reset SCSI bus
+	 */
+	nsp32_write1(base, SCSI_BUS_CONTROL, BUSCTL_RST);
+	udelay(RESET_HOLD_TIME);
+	nsp32_write1(base, SCSI_BUS_CONTROL, 0);
+	for(i = 0; i < 5; i++) {
+		intrdat = nsp32_read2(base, IRQ_STATUS); /* dummy read */
+		nsp32_dbg(NSP32_DEBUG_BUSRESET, "irq:1: 0x%x", intrdat);
+        }
 
-	nsp32_msg(KERN_WARNING, "wait SACK timeout, state: %d", state);
+	data->CurrentSC = NULL;
 }
 
-/*
- * assert SCSI ACK
- *
- * Note: SCSI ACK assertion needs with ACKENB=1, AUTODIRECTION=1.
- */
-static void nsp32_sack_assert(nsp32_hw_data *data)
+static int nsp32_eh_host_reset(Scsi_Cmnd *SCpnt)
 {
-	unsigned char busctrl;
-	unsigned int base = data->BaseAddress;
+	struct Scsi_Host *host = SCpnt->device->host;
+	unsigned int      base = SCpnt->device->host->io_port;
+	nsp32_hw_data    *data = (nsp32_hw_data *)host->hostdata;
 
-	busctrl  = nsp32_read1(base, SCSI_BUS_CONTROL);
-	busctrl	|= (BUSCTL_ACK | AUTODIRECTION | ACKENB);
-	nsp32_write1(base, SCSI_BUS_CONTROL,busctrl);
-}
+	nsp32_msg(KERN_INFO, "Host Reset");	
+	nsp32_dbg(NSP32_DEBUG_BUSRESET, "SCpnt=0x%x", SCpnt);
 
-/*
- * negate SCSI ACK
- */
-static void nsp32_sack_negate(nsp32_hw_data *data)
-{
-	unsigned char busctrl;
-	unsigned int base = data->BaseAddress;
+	nsp32hw_init(data);
+	nsp32_write2(base, IRQ_CONTROL, IRQ_CONTROL_ALL_IRQ_MASK);
+	nsp32_do_bus_reset(data);
+	nsp32_write2(base, IRQ_CONTROL, 0);
 
-	busctrl  = nsp32_read1(base, SCSI_BUS_CONTROL);
-	busctrl	&= ~BUSCTL_ACK;
-	nsp32_write1(base, SCSI_BUS_CONTROL, busctrl);
+	return SUCCESS;	/* Host reset is succeeded at any time. */
 }
 
 
+/**************************************************************************
+ * EEPROM handler
+ */
 
 /*
  * getting EEPROM parameter
